﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Interactivity;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Syncfusion.Windows.Shared;
using Syncfusion.Windows.Tools.Controls;

namespace DockingManager_F129482
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
            DataContext = this;
        }
       
        private ICommand _WindowStateCahangedCommand;
        public ICommand WindowStateCahangedCommand
        {
            get
            {
                if (_WindowStateCahangedCommand == null)
                {
                    _WindowStateCahangedCommand = new DelegateCommand(ExecuteWindowStateChange, CanExecute);
                }
                return _WindowStateCahangedCommand;
            }
            set { _WindowStateCahangedCommand = value; }
        }

        private bool CanExecute(object arg)
        {
            return true;
        }

        private void ExecuteWindowStateChange(object obj)
        {
            System.Diagnostics.Debug.WriteLine("fired");
        }
        
    }
    public class DocumentContainerStateChangebehavior  : Behavior<Control>
    {
        protected override void OnAttached()
        {
            AssociatedObject.AddHandler(DocumentContainer.MDIWindowStateChanged, new RoutedPropertyChangedEventHandler<MDIWindowState>(OnWindowStateChanged));
            base.OnAttached();
        }
        private void OnWindowStateChanged(object sender, RoutedPropertyChangedEventArgs<MDIWindowState> args)
        {
            if(Command != null)
            {
                if (Command.CanExecute(CommandParameter))
                    Command.Execute(CommandParameter);
            }
        }


        public ICommand Command
        {
            get { return (ICommand)GetValue(CommandProperty); }
            set { SetValue(CommandProperty, value); }
        }

        // Using a DependencyProperty as the backing store for Command.  This enables animation, styling, binding, etc...
        public static readonly DependencyProperty CommandProperty =
            DependencyProperty.Register("Command", typeof(ICommand), typeof(DocumentContainerStateChangebehavior), new PropertyMetadata(null));



        public Object CommandParameter
        {
            get { return (Object)GetValue(CommandParameterProperty); }
            set { SetValue(CommandParameterProperty, value); }
        }

        // Using a DependencyProperty as the backing store for CommandParameter.  This enables animation, styling, binding, etc...
        public static readonly DependencyProperty CommandParameterProperty =
            DependencyProperty.Register("CommandParameter", typeof(Object), typeof(DocumentContainerStateChangebehavior), new PropertyMetadata(null));


    }
}
